Problems With the Existing API